<template>
  <div>
    <div class="form-row">
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        no-wrap
      />
      <div class="form-group col-12">
        <label 
          class="required"
          style="margin-top: 1em;"
        >
          Base de données
        </label>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="BD name"
          :rules="`${isRequired ? 'required' : ''}`"
        >
          <div
            class="control"
            :class="classes"
          >
            <Multiselect
              v-model="form.bd"
              :options="bdOptions"
              :class="isRequired ? classes : ''"
              track-by="codename"
              label="display_name"
              select-label=""
              selected-label=""
              deselect-label=""
              :searchable="false"
              placeholder="Sélectionner une base de données"
            />
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
      <div class="form-group col-12">
        <label 
          class="required"
          style="margin-top: 1em;"
        >
          Schéma
        </label>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Format FTP"
          :rules="`${isRequired ? 'required' : ''}`"
        >
          <div
            class="control"
            :class="isRequired ? classes : ''"
          >
            <Multiselect
              v-model="form.schema"
              :options="schemaOptions"
              :class="isRequired ? classes : ''"
              track-by="codename"
              label="display_name"
              select-label=""
              selected-label=""
              deselect-label=""
              :searchable="false"
              placeholder="Sélectionner un schéma"
            />
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
      <div class="form-group col-12">
        <label 
          class="required"
          style="margin-top: 1em;"
        >
          Table
        </label>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Format FTP"
          :rules="`${isRequired ? 'required' : ''}`"
        >
          <div
            class="control"
            :class="isRequired ? classes : ''"
          >
            <Multiselect
              v-model="form.table"
              :options="tableOptions"
              :class="isRequired ? classes : ''"
              track-by="codename"
              label="display_name"
              select-label=""
              selected-label=""
              deselect-label=""
              :searchable="false"
              placeholder="Sélectionner une table"
            />
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
    </div>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';

import { ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'BDResourceCreator',

  components: {
    Multiselect,
    ValidationProvider
  },

  props: {
    required: {
      type: Boolean,
      default: true
    }
  },

  data() {
    return {
      loading: false,
      isRequired: true,
      form: {
        bd: null,
        schema: null,
        table: null
      },
      bdOptions: [],
      schemaOptions: [],
      tableOptions: [],
    }
  },

  watch: {
    required(newValue) {
      this.isRequired = newValue;
    }
  },

  created() {
    this.isRequired = this.required;
  },

  methods: {
    setRequired(e) {
      this.isRequired = e;
    },
  }
}
</script>
